import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { AssociateFacesCommandInput, AssociateFacesCommandOutput } from "../commands/AssociateFacesCommand";
import { CompareFacesCommandInput, CompareFacesCommandOutput } from "../commands/CompareFacesCommand";
import { CopyProjectVersionCommandInput, CopyProjectVersionCommandOutput } from "../commands/CopyProjectVersionCommand";
import { CreateCollectionCommandInput, CreateCollectionCommandOutput } from "../commands/CreateCollectionCommand";
import { CreateDatasetCommandInput, CreateDatasetCommandOutput } from "../commands/CreateDatasetCommand";
import { CreateFaceLivenessSessionCommandInput, CreateFaceLivenessSessionCommandOutput } from "../commands/CreateFaceLivenessSessionCommand";
import { CreateProjectCommandInput, CreateProjectCommandOutput } from "../commands/CreateProjectCommand";
import { CreateProjectVersionCommandInput, CreateProjectVersionCommandOutput } from "../commands/CreateProjectVersionCommand";
import { CreateStreamProcessorCommandInput, CreateStreamProcessorCommandOutput } from "../commands/CreateStreamProcessorCommand";
import { CreateUserCommandInput, CreateUserCommandOutput } from "../commands/CreateUserCommand";
import { DeleteCollectionCommandInput, DeleteCollectionCommandOutput } from "../commands/DeleteCollectionCommand";
import { DeleteDatasetCommandInput, DeleteDatasetCommandOutput } from "../commands/DeleteDatasetCommand";
import { DeleteFacesCommandInput, DeleteFacesCommandOutput } from "../commands/DeleteFacesCommand";
import { DeleteProjectCommandInput, DeleteProjectCommandOutput } from "../commands/DeleteProjectCommand";
import { DeleteProjectPolicyCommandInput, DeleteProjectPolicyCommandOutput } from "../commands/DeleteProjectPolicyCommand";
import { DeleteProjectVersionCommandInput, DeleteProjectVersionCommandOutput } from "../commands/DeleteProjectVersionCommand";
import { DeleteStreamProcessorCommandInput, DeleteStreamProcessorCommandOutput } from "../commands/DeleteStreamProcessorCommand";
import { DeleteUserCommandInput, DeleteUserCommandOutput } from "../commands/DeleteUserCommand";
import { DescribeCollectionCommandInput, DescribeCollectionCommandOutput } from "../commands/DescribeCollectionCommand";
import { DescribeDatasetCommandInput, DescribeDatasetCommandOutput } from "../commands/DescribeDatasetCommand";
import { DescribeProjectsCommandInput, DescribeProjectsCommandOutput } from "../commands/DescribeProjectsCommand";
import { DescribeProjectVersionsCommandInput, DescribeProjectVersionsCommandOutput } from "../commands/DescribeProjectVersionsCommand";
import { DescribeStreamProcessorCommandInput, DescribeStreamProcessorCommandOutput } from "../commands/DescribeStreamProcessorCommand";
import { DetectCustomLabelsCommandInput, DetectCustomLabelsCommandOutput } from "../commands/DetectCustomLabelsCommand";
import { DetectFacesCommandInput, DetectFacesCommandOutput } from "../commands/DetectFacesCommand";
import { DetectLabelsCommandInput, DetectLabelsCommandOutput } from "../commands/DetectLabelsCommand";
import { DetectModerationLabelsCommandInput, DetectModerationLabelsCommandOutput } from "../commands/DetectModerationLabelsCommand";
import { DetectProtectiveEquipmentCommandInput, DetectProtectiveEquipmentCommandOutput } from "../commands/DetectProtectiveEquipmentCommand";
import { DetectTextCommandInput, DetectTextCommandOutput } from "../commands/DetectTextCommand";
import { DisassociateFacesCommandInput, DisassociateFacesCommandOutput } from "../commands/DisassociateFacesCommand";
import { DistributeDatasetEntriesCommandInput, DistributeDatasetEntriesCommandOutput } from "../commands/DistributeDatasetEntriesCommand";
import { GetCelebrityInfoCommandInput, GetCelebrityInfoCommandOutput } from "../commands/GetCelebrityInfoCommand";
import { GetCelebrityRecognitionCommandInput, GetCelebrityRecognitionCommandOutput } from "../commands/GetCelebrityRecognitionCommand";
import { GetContentModerationCommandInput, GetContentModerationCommandOutput } from "../commands/GetContentModerationCommand";
import { GetFaceDetectionCommandInput, GetFaceDetectionCommandOutput } from "../commands/GetFaceDetectionCommand";
import { GetFaceLivenessSessionResultsCommandInput, GetFaceLivenessSessionResultsCommandOutput } from "../commands/GetFaceLivenessSessionResultsCommand";
import { GetFaceSearchCommandInput, GetFaceSearchCommandOutput } from "../commands/GetFaceSearchCommand";
import { GetLabelDetectionCommandInput, GetLabelDetectionCommandOutput } from "../commands/GetLabelDetectionCommand";
import { GetMediaAnalysisJobCommandInput, GetMediaAnalysisJobCommandOutput } from "../commands/GetMediaAnalysisJobCommand";
import { GetPersonTrackingCommandInput, GetPersonTrackingCommandOutput } from "../commands/GetPersonTrackingCommand";
import { GetSegmentDetectionCommandInput, GetSegmentDetectionCommandOutput } from "../commands/GetSegmentDetectionCommand";
import { GetTextDetectionCommandInput, GetTextDetectionCommandOutput } from "../commands/GetTextDetectionCommand";
import { IndexFacesCommandInput, IndexFacesCommandOutput } from "../commands/IndexFacesCommand";
import { ListCollectionsCommandInput, ListCollectionsCommandOutput } from "../commands/ListCollectionsCommand";
import { ListDatasetEntriesCommandInput, ListDatasetEntriesCommandOutput } from "../commands/ListDatasetEntriesCommand";
import { ListDatasetLabelsCommandInput, ListDatasetLabelsCommandOutput } from "../commands/ListDatasetLabelsCommand";
import { ListFacesCommandInput, ListFacesCommandOutput } from "../commands/ListFacesCommand";
import { ListMediaAnalysisJobsCommandInput, ListMediaAnalysisJobsCommandOutput } from "../commands/ListMediaAnalysisJobsCommand";
import { ListProjectPoliciesCommandInput, ListProjectPoliciesCommandOutput } from "../commands/ListProjectPoliciesCommand";
import { ListStreamProcessorsCommandInput, ListStreamProcessorsCommandOutput } from "../commands/ListStreamProcessorsCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { ListUsersCommandInput, ListUsersCommandOutput } from "../commands/ListUsersCommand";
import { PutProjectPolicyCommandInput, PutProjectPolicyCommandOutput } from "../commands/PutProjectPolicyCommand";
import { RecognizeCelebritiesCommandInput, RecognizeCelebritiesCommandOutput } from "../commands/RecognizeCelebritiesCommand";
import { SearchFacesByImageCommandInput, SearchFacesByImageCommandOutput } from "../commands/SearchFacesByImageCommand";
import { SearchFacesCommandInput, SearchFacesCommandOutput } from "../commands/SearchFacesCommand";
import { SearchUsersByImageCommandInput, SearchUsersByImageCommandOutput } from "../commands/SearchUsersByImageCommand";
import { SearchUsersCommandInput, SearchUsersCommandOutput } from "../commands/SearchUsersCommand";
import { StartCelebrityRecognitionCommandInput, StartCelebrityRecognitionCommandOutput } from "../commands/StartCelebrityRecognitionCommand";
import { StartContentModerationCommandInput, StartContentModerationCommandOutput } from "../commands/StartContentModerationCommand";
import { StartFaceDetectionCommandInput, StartFaceDetectionCommandOutput } from "../commands/StartFaceDetectionCommand";
import { StartFaceSearchCommandInput, StartFaceSearchCommandOutput } from "../commands/StartFaceSearchCommand";
import { StartLabelDetectionCommandInput, StartLabelDetectionCommandOutput } from "../commands/StartLabelDetectionCommand";
import { StartMediaAnalysisJobCommandInput, StartMediaAnalysisJobCommandOutput } from "../commands/StartMediaAnalysisJobCommand";
import { StartPersonTrackingCommandInput, StartPersonTrackingCommandOutput } from "../commands/StartPersonTrackingCommand";
import { StartProjectVersionCommandInput, StartProjectVersionCommandOutput } from "../commands/StartProjectVersionCommand";
import { StartSegmentDetectionCommandInput, StartSegmentDetectionCommandOutput } from "../commands/StartSegmentDetectionCommand";
import { StartStreamProcessorCommandInput, StartStreamProcessorCommandOutput } from "../commands/StartStreamProcessorCommand";
import { StartTextDetectionCommandInput, StartTextDetectionCommandOutput } from "../commands/StartTextDetectionCommand";
import { StopProjectVersionCommandInput, StopProjectVersionCommandOutput } from "../commands/StopProjectVersionCommand";
import { StopStreamProcessorCommandInput, StopStreamProcessorCommandOutput } from "../commands/StopStreamProcessorCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateDatasetEntriesCommandInput, UpdateDatasetEntriesCommandOutput } from "../commands/UpdateDatasetEntriesCommand";
import { UpdateStreamProcessorCommandInput, UpdateStreamProcessorCommandOutput } from "../commands/UpdateStreamProcessorCommand";
/**
 * serializeAws_json1_1AssociateFacesCommand
 */
export declare const se_AssociateFacesCommand: (input: AssociateFacesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CompareFacesCommand
 */
export declare const se_CompareFacesCommand: (input: CompareFacesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CopyProjectVersionCommand
 */
export declare const se_CopyProjectVersionCommand: (input: CopyProjectVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateCollectionCommand
 */
export declare const se_CreateCollectionCommand: (input: CreateCollectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateDatasetCommand
 */
export declare const se_CreateDatasetCommand: (input: CreateDatasetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateFaceLivenessSessionCommand
 */
export declare const se_CreateFaceLivenessSessionCommand: (input: CreateFaceLivenessSessionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateProjectCommand
 */
export declare const se_CreateProjectCommand: (input: CreateProjectCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateProjectVersionCommand
 */
export declare const se_CreateProjectVersionCommand: (input: CreateProjectVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateStreamProcessorCommand
 */
export declare const se_CreateStreamProcessorCommand: (input: CreateStreamProcessorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateUserCommand
 */
export declare const se_CreateUserCommand: (input: CreateUserCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteCollectionCommand
 */
export declare const se_DeleteCollectionCommand: (input: DeleteCollectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteDatasetCommand
 */
export declare const se_DeleteDatasetCommand: (input: DeleteDatasetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteFacesCommand
 */
export declare const se_DeleteFacesCommand: (input: DeleteFacesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteProjectCommand
 */
export declare const se_DeleteProjectCommand: (input: DeleteProjectCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteProjectPolicyCommand
 */
export declare const se_DeleteProjectPolicyCommand: (input: DeleteProjectPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteProjectVersionCommand
 */
export declare const se_DeleteProjectVersionCommand: (input: DeleteProjectVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteStreamProcessorCommand
 */
export declare const se_DeleteStreamProcessorCommand: (input: DeleteStreamProcessorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteUserCommand
 */
export declare const se_DeleteUserCommand: (input: DeleteUserCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeCollectionCommand
 */
export declare const se_DescribeCollectionCommand: (input: DescribeCollectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeDatasetCommand
 */
export declare const se_DescribeDatasetCommand: (input: DescribeDatasetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeProjectsCommand
 */
export declare const se_DescribeProjectsCommand: (input: DescribeProjectsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeProjectVersionsCommand
 */
export declare const se_DescribeProjectVersionsCommand: (input: DescribeProjectVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeStreamProcessorCommand
 */
export declare const se_DescribeStreamProcessorCommand: (input: DescribeStreamProcessorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DetectCustomLabelsCommand
 */
export declare const se_DetectCustomLabelsCommand: (input: DetectCustomLabelsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DetectFacesCommand
 */
export declare const se_DetectFacesCommand: (input: DetectFacesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DetectLabelsCommand
 */
export declare const se_DetectLabelsCommand: (input: DetectLabelsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DetectModerationLabelsCommand
 */
export declare const se_DetectModerationLabelsCommand: (input: DetectModerationLabelsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DetectProtectiveEquipmentCommand
 */
export declare const se_DetectProtectiveEquipmentCommand: (input: DetectProtectiveEquipmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DetectTextCommand
 */
export declare const se_DetectTextCommand: (input: DetectTextCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DisassociateFacesCommand
 */
export declare const se_DisassociateFacesCommand: (input: DisassociateFacesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DistributeDatasetEntriesCommand
 */
export declare const se_DistributeDatasetEntriesCommand: (input: DistributeDatasetEntriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetCelebrityInfoCommand
 */
export declare const se_GetCelebrityInfoCommand: (input: GetCelebrityInfoCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetCelebrityRecognitionCommand
 */
export declare const se_GetCelebrityRecognitionCommand: (input: GetCelebrityRecognitionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetContentModerationCommand
 */
export declare const se_GetContentModerationCommand: (input: GetContentModerationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetFaceDetectionCommand
 */
export declare const se_GetFaceDetectionCommand: (input: GetFaceDetectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetFaceLivenessSessionResultsCommand
 */
export declare const se_GetFaceLivenessSessionResultsCommand: (input: GetFaceLivenessSessionResultsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetFaceSearchCommand
 */
export declare const se_GetFaceSearchCommand: (input: GetFaceSearchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetLabelDetectionCommand
 */
export declare const se_GetLabelDetectionCommand: (input: GetLabelDetectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetMediaAnalysisJobCommand
 */
export declare const se_GetMediaAnalysisJobCommand: (input: GetMediaAnalysisJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetPersonTrackingCommand
 */
export declare const se_GetPersonTrackingCommand: (input: GetPersonTrackingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetSegmentDetectionCommand
 */
export declare const se_GetSegmentDetectionCommand: (input: GetSegmentDetectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetTextDetectionCommand
 */
export declare const se_GetTextDetectionCommand: (input: GetTextDetectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1IndexFacesCommand
 */
export declare const se_IndexFacesCommand: (input: IndexFacesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListCollectionsCommand
 */
export declare const se_ListCollectionsCommand: (input: ListCollectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListDatasetEntriesCommand
 */
export declare const se_ListDatasetEntriesCommand: (input: ListDatasetEntriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListDatasetLabelsCommand
 */
export declare const se_ListDatasetLabelsCommand: (input: ListDatasetLabelsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListFacesCommand
 */
export declare const se_ListFacesCommand: (input: ListFacesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListMediaAnalysisJobsCommand
 */
export declare const se_ListMediaAnalysisJobsCommand: (input: ListMediaAnalysisJobsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListProjectPoliciesCommand
 */
export declare const se_ListProjectPoliciesCommand: (input: ListProjectPoliciesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListStreamProcessorsCommand
 */
export declare const se_ListStreamProcessorsCommand: (input: ListStreamProcessorsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListUsersCommand
 */
export declare const se_ListUsersCommand: (input: ListUsersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutProjectPolicyCommand
 */
export declare const se_PutProjectPolicyCommand: (input: PutProjectPolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1RecognizeCelebritiesCommand
 */
export declare const se_RecognizeCelebritiesCommand: (input: RecognizeCelebritiesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1SearchFacesCommand
 */
export declare const se_SearchFacesCommand: (input: SearchFacesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1SearchFacesByImageCommand
 */
export declare const se_SearchFacesByImageCommand: (input: SearchFacesByImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1SearchUsersCommand
 */
export declare const se_SearchUsersCommand: (input: SearchUsersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1SearchUsersByImageCommand
 */
export declare const se_SearchUsersByImageCommand: (input: SearchUsersByImageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartCelebrityRecognitionCommand
 */
export declare const se_StartCelebrityRecognitionCommand: (input: StartCelebrityRecognitionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartContentModerationCommand
 */
export declare const se_StartContentModerationCommand: (input: StartContentModerationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartFaceDetectionCommand
 */
export declare const se_StartFaceDetectionCommand: (input: StartFaceDetectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartFaceSearchCommand
 */
export declare const se_StartFaceSearchCommand: (input: StartFaceSearchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartLabelDetectionCommand
 */
export declare const se_StartLabelDetectionCommand: (input: StartLabelDetectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartMediaAnalysisJobCommand
 */
export declare const se_StartMediaAnalysisJobCommand: (input: StartMediaAnalysisJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartPersonTrackingCommand
 */
export declare const se_StartPersonTrackingCommand: (input: StartPersonTrackingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartProjectVersionCommand
 */
export declare const se_StartProjectVersionCommand: (input: StartProjectVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartSegmentDetectionCommand
 */
export declare const se_StartSegmentDetectionCommand: (input: StartSegmentDetectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartStreamProcessorCommand
 */
export declare const se_StartStreamProcessorCommand: (input: StartStreamProcessorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartTextDetectionCommand
 */
export declare const se_StartTextDetectionCommand: (input: StartTextDetectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StopProjectVersionCommand
 */
export declare const se_StopProjectVersionCommand: (input: StopProjectVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StopStreamProcessorCommand
 */
export declare const se_StopStreamProcessorCommand: (input: StopStreamProcessorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateDatasetEntriesCommand
 */
export declare const se_UpdateDatasetEntriesCommand: (input: UpdateDatasetEntriesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateStreamProcessorCommand
 */
export declare const se_UpdateStreamProcessorCommand: (input: UpdateStreamProcessorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_json1_1AssociateFacesCommand
 */
export declare const de_AssociateFacesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociateFacesCommandOutput>;
/**
 * deserializeAws_json1_1CompareFacesCommand
 */
export declare const de_CompareFacesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CompareFacesCommandOutput>;
/**
 * deserializeAws_json1_1CopyProjectVersionCommand
 */
export declare const de_CopyProjectVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CopyProjectVersionCommandOutput>;
/**
 * deserializeAws_json1_1CreateCollectionCommand
 */
export declare const de_CreateCollectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCollectionCommandOutput>;
/**
 * deserializeAws_json1_1CreateDatasetCommand
 */
export declare const de_CreateDatasetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDatasetCommandOutput>;
/**
 * deserializeAws_json1_1CreateFaceLivenessSessionCommand
 */
export declare const de_CreateFaceLivenessSessionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateFaceLivenessSessionCommandOutput>;
/**
 * deserializeAws_json1_1CreateProjectCommand
 */
export declare const de_CreateProjectCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateProjectCommandOutput>;
/**
 * deserializeAws_json1_1CreateProjectVersionCommand
 */
export declare const de_CreateProjectVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateProjectVersionCommandOutput>;
/**
 * deserializeAws_json1_1CreateStreamProcessorCommand
 */
export declare const de_CreateStreamProcessorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateStreamProcessorCommandOutput>;
/**
 * deserializeAws_json1_1CreateUserCommand
 */
export declare const de_CreateUserCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateUserCommandOutput>;
/**
 * deserializeAws_json1_1DeleteCollectionCommand
 */
export declare const de_DeleteCollectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteCollectionCommandOutput>;
/**
 * deserializeAws_json1_1DeleteDatasetCommand
 */
export declare const de_DeleteDatasetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDatasetCommandOutput>;
/**
 * deserializeAws_json1_1DeleteFacesCommand
 */
export declare const de_DeleteFacesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteFacesCommandOutput>;
/**
 * deserializeAws_json1_1DeleteProjectCommand
 */
export declare const de_DeleteProjectCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteProjectCommandOutput>;
/**
 * deserializeAws_json1_1DeleteProjectPolicyCommand
 */
export declare const de_DeleteProjectPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteProjectPolicyCommandOutput>;
/**
 * deserializeAws_json1_1DeleteProjectVersionCommand
 */
export declare const de_DeleteProjectVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteProjectVersionCommandOutput>;
/**
 * deserializeAws_json1_1DeleteStreamProcessorCommand
 */
export declare const de_DeleteStreamProcessorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteStreamProcessorCommandOutput>;
/**
 * deserializeAws_json1_1DeleteUserCommand
 */
export declare const de_DeleteUserCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteUserCommandOutput>;
/**
 * deserializeAws_json1_1DescribeCollectionCommand
 */
export declare const de_DescribeCollectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeCollectionCommandOutput>;
/**
 * deserializeAws_json1_1DescribeDatasetCommand
 */
export declare const de_DescribeDatasetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDatasetCommandOutput>;
/**
 * deserializeAws_json1_1DescribeProjectsCommand
 */
export declare const de_DescribeProjectsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeProjectsCommandOutput>;
/**
 * deserializeAws_json1_1DescribeProjectVersionsCommand
 */
export declare const de_DescribeProjectVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeProjectVersionsCommandOutput>;
/**
 * deserializeAws_json1_1DescribeStreamProcessorCommand
 */
export declare const de_DescribeStreamProcessorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeStreamProcessorCommandOutput>;
/**
 * deserializeAws_json1_1DetectCustomLabelsCommand
 */
export declare const de_DetectCustomLabelsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetectCustomLabelsCommandOutput>;
/**
 * deserializeAws_json1_1DetectFacesCommand
 */
export declare const de_DetectFacesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetectFacesCommandOutput>;
/**
 * deserializeAws_json1_1DetectLabelsCommand
 */
export declare const de_DetectLabelsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetectLabelsCommandOutput>;
/**
 * deserializeAws_json1_1DetectModerationLabelsCommand
 */
export declare const de_DetectModerationLabelsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetectModerationLabelsCommandOutput>;
/**
 * deserializeAws_json1_1DetectProtectiveEquipmentCommand
 */
export declare const de_DetectProtectiveEquipmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetectProtectiveEquipmentCommandOutput>;
/**
 * deserializeAws_json1_1DetectTextCommand
 */
export declare const de_DetectTextCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetectTextCommandOutput>;
/**
 * deserializeAws_json1_1DisassociateFacesCommand
 */
export declare const de_DisassociateFacesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisassociateFacesCommandOutput>;
/**
 * deserializeAws_json1_1DistributeDatasetEntriesCommand
 */
export declare const de_DistributeDatasetEntriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DistributeDatasetEntriesCommandOutput>;
/**
 * deserializeAws_json1_1GetCelebrityInfoCommand
 */
export declare const de_GetCelebrityInfoCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCelebrityInfoCommandOutput>;
/**
 * deserializeAws_json1_1GetCelebrityRecognitionCommand
 */
export declare const de_GetCelebrityRecognitionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCelebrityRecognitionCommandOutput>;
/**
 * deserializeAws_json1_1GetContentModerationCommand
 */
export declare const de_GetContentModerationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetContentModerationCommandOutput>;
/**
 * deserializeAws_json1_1GetFaceDetectionCommand
 */
export declare const de_GetFaceDetectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetFaceDetectionCommandOutput>;
/**
 * deserializeAws_json1_1GetFaceLivenessSessionResultsCommand
 */
export declare const de_GetFaceLivenessSessionResultsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetFaceLivenessSessionResultsCommandOutput>;
/**
 * deserializeAws_json1_1GetFaceSearchCommand
 */
export declare const de_GetFaceSearchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetFaceSearchCommandOutput>;
/**
 * deserializeAws_json1_1GetLabelDetectionCommand
 */
export declare const de_GetLabelDetectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetLabelDetectionCommandOutput>;
/**
 * deserializeAws_json1_1GetMediaAnalysisJobCommand
 */
export declare const de_GetMediaAnalysisJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMediaAnalysisJobCommandOutput>;
/**
 * deserializeAws_json1_1GetPersonTrackingCommand
 */
export declare const de_GetPersonTrackingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPersonTrackingCommandOutput>;
/**
 * deserializeAws_json1_1GetSegmentDetectionCommand
 */
export declare const de_GetSegmentDetectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetSegmentDetectionCommandOutput>;
/**
 * deserializeAws_json1_1GetTextDetectionCommand
 */
export declare const de_GetTextDetectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTextDetectionCommandOutput>;
/**
 * deserializeAws_json1_1IndexFacesCommand
 */
export declare const de_IndexFacesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<IndexFacesCommandOutput>;
/**
 * deserializeAws_json1_1ListCollectionsCommand
 */
export declare const de_ListCollectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListCollectionsCommandOutput>;
/**
 * deserializeAws_json1_1ListDatasetEntriesCommand
 */
export declare const de_ListDatasetEntriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDatasetEntriesCommandOutput>;
/**
 * deserializeAws_json1_1ListDatasetLabelsCommand
 */
export declare const de_ListDatasetLabelsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDatasetLabelsCommandOutput>;
/**
 * deserializeAws_json1_1ListFacesCommand
 */
export declare const de_ListFacesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListFacesCommandOutput>;
/**
 * deserializeAws_json1_1ListMediaAnalysisJobsCommand
 */
export declare const de_ListMediaAnalysisJobsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListMediaAnalysisJobsCommandOutput>;
/**
 * deserializeAws_json1_1ListProjectPoliciesCommand
 */
export declare const de_ListProjectPoliciesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListProjectPoliciesCommandOutput>;
/**
 * deserializeAws_json1_1ListStreamProcessorsCommand
 */
export declare const de_ListStreamProcessorsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListStreamProcessorsCommandOutput>;
/**
 * deserializeAws_json1_1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_json1_1ListUsersCommand
 */
export declare const de_ListUsersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListUsersCommandOutput>;
/**
 * deserializeAws_json1_1PutProjectPolicyCommand
 */
export declare const de_PutProjectPolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutProjectPolicyCommandOutput>;
/**
 * deserializeAws_json1_1RecognizeCelebritiesCommand
 */
export declare const de_RecognizeCelebritiesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RecognizeCelebritiesCommandOutput>;
/**
 * deserializeAws_json1_1SearchFacesCommand
 */
export declare const de_SearchFacesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SearchFacesCommandOutput>;
/**
 * deserializeAws_json1_1SearchFacesByImageCommand
 */
export declare const de_SearchFacesByImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SearchFacesByImageCommandOutput>;
/**
 * deserializeAws_json1_1SearchUsersCommand
 */
export declare const de_SearchUsersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SearchUsersCommandOutput>;
/**
 * deserializeAws_json1_1SearchUsersByImageCommand
 */
export declare const de_SearchUsersByImageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SearchUsersByImageCommandOutput>;
/**
 * deserializeAws_json1_1StartCelebrityRecognitionCommand
 */
export declare const de_StartCelebrityRecognitionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartCelebrityRecognitionCommandOutput>;
/**
 * deserializeAws_json1_1StartContentModerationCommand
 */
export declare const de_StartContentModerationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartContentModerationCommandOutput>;
/**
 * deserializeAws_json1_1StartFaceDetectionCommand
 */
export declare const de_StartFaceDetectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartFaceDetectionCommandOutput>;
/**
 * deserializeAws_json1_1StartFaceSearchCommand
 */
export declare const de_StartFaceSearchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartFaceSearchCommandOutput>;
/**
 * deserializeAws_json1_1StartLabelDetectionCommand
 */
export declare const de_StartLabelDetectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartLabelDetectionCommandOutput>;
/**
 * deserializeAws_json1_1StartMediaAnalysisJobCommand
 */
export declare const de_StartMediaAnalysisJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartMediaAnalysisJobCommandOutput>;
/**
 * deserializeAws_json1_1StartPersonTrackingCommand
 */
export declare const de_StartPersonTrackingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartPersonTrackingCommandOutput>;
/**
 * deserializeAws_json1_1StartProjectVersionCommand
 */
export declare const de_StartProjectVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartProjectVersionCommandOutput>;
/**
 * deserializeAws_json1_1StartSegmentDetectionCommand
 */
export declare const de_StartSegmentDetectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartSegmentDetectionCommandOutput>;
/**
 * deserializeAws_json1_1StartStreamProcessorCommand
 */
export declare const de_StartStreamProcessorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartStreamProcessorCommandOutput>;
/**
 * deserializeAws_json1_1StartTextDetectionCommand
 */
export declare const de_StartTextDetectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartTextDetectionCommandOutput>;
/**
 * deserializeAws_json1_1StopProjectVersionCommand
 */
export declare const de_StopProjectVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopProjectVersionCommandOutput>;
/**
 * deserializeAws_json1_1StopStreamProcessorCommand
 */
export declare const de_StopStreamProcessorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopStreamProcessorCommandOutput>;
/**
 * deserializeAws_json1_1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UpdateDatasetEntriesCommand
 */
export declare const de_UpdateDatasetEntriesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateDatasetEntriesCommandOutput>;
/**
 * deserializeAws_json1_1UpdateStreamProcessorCommand
 */
export declare const de_UpdateStreamProcessorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateStreamProcessorCommandOutput>;
